.TH SGMPQUERY LOCAL "October 1 1987"
.SH NAME
sgmpquery \- Simple SGMP querying application
.SH SYNOPSIS
.B sgmpquery [-s session_name] gateway variable
.SH DESCRIPTION
.LP
.I sgmpquery
is a simple querying application that allows the interrogation of
Internet gateways running the
.I Simple Gateway Monitoring Protocol
from the command line. It is intended as a 'quick and dirty' way of
querying a gateway once or twice for arbitrary SGMP variables.
.LP
When
.I sgmpquery
is invoked with arguments
.I gateway
and
.I variable,
the gateway \fIgateway\fR (either a dot notation address such
as '128.84.248.254' or a name such as 'csgwd.rpi.edu')
will be queried for the value of the SGMP variable
.I variable.
This application will print out the name and the value of the variable
queried for upon successful return.
If a session name other than the default of 'public' is to be used in
the query, this session name can be specified with the -s option.
In this event, where the -s option is used, the query sent out will have
session name
.I session_name,
instead of the default of
.I public.
.SH FILES
.in +5
/etc/sgmp.variables		default variable initfile
.br
/etc/services			to find the 'sgmp' service
.in -5
.SH SEE ALSO
sgmpask(l), sgmplookup(l), sgmproute(l), sgmpwatch(l), "A Simple Gateway
Monitoring Protocol", RFC 1028, by J.R. Davin, J.D. Case, M.S. Fedor,
M.L. Schoffstall.
